AppTitle "!!!"	; -   !!! :)
Graphics3D 800,600,32	;   
SetBuffer BackBuffer()
SeedRnd MilliSecs()		;     

Type Egg				;  -    :)
	Field ent			;     
	Field dx#,dy#,dz#	;    , , 
End Type

Const TPlayer=1,TWall=2,TEgg=3	;    ,   
Global score%,broken%			;   /

Global MeshEgg=CreateSphere()		;     - 
EntityColor MeshEgg,230,240,255		;   
ScaleEntity MeshEgg,0.9,0.5,0.9		; 
HideEntity MeshEgg					;  

Global player=CreateCylinder()	;     
EntityColor player,150,100,150	;  
EntityType player,TPlayer		;     ,      , ..   ,     

Global cam=CreateCamera()		;  
CameraFogMode cam,1				;  
CameraFogRange cam,1,300		;  300  - !
MoveEntity cam,0,10,-12.5		;   ,    
;MoveEntity cam,0,20,-0

SetFont LoadFont("",50)		;      

CreateWorld()		;  :        

Collisions TEgg,TWall,2,2		;     (    -      )
Collisions TEgg,TPlayer,2,1		;    

Global timer=CreateTimer(75)	;     c  
Local time=MilliSecs()			;       

Repeat							;  
	If time+1400<MilliSecs() Then	;      1400 , 
		CreateEgg()					;     
		time=MilliSecs()			;   
	EndIf
	UpdateEggs()				;        
	UpdatePlayer()				;   
	PointEntity cam,player		;      
	UpdateWorld()				;     
	RenderWorld()				;  
	Color 255,255,255			;   
	Text 10,450,": "+score		;  
	Text 10,500,": "+broken	;   
	Flip 0					;     (  , ..   )
	WaitTimer timer			;       
Until KeyDown(1)			;   ,    

Function CreateEgg(typ=0)		;    
	If typ=0 Then typ=Rand(1,4)	;    0,      
	Local sp#=0.2				;  ,     
	Select typ					;      
		Case 1: NewEgg -6.5,20,7,0,-sp,0	; ,  
		Case 2: NewEgg -2.1,20,7,0,-sp,0	;  
		Case 3: NewEgg  2.1,20,7,0,-sp,0	;  
		Case 4: NewEgg  6.5,20,7,0,-sp,0	;  
	End Select
End Function

Function NewEgg.Egg(x#,y#,z#,dx#=0,dy#=0,dz#=0)	;         
	Local e.Egg=New Egg				;     
	e\ent=CopyEntity(MeshEgg)		;     
	PositionEntity e\ent,x,y,z		;     
	EntityType e\ent,TEgg			;    .   , ..    ,               
	e\dx=dx:e\dy=dy:e\dz=dz			;      
	Return e						;       ,   :)
End Function

Function UpdateEggs()		;   
	Local e.Egg				;      
	For e=Each Egg			;   :)
		TranslateEntity e\ent,e\dx,e\dy,e\dz	;    ,     
		If EntityCollided(e\ent,TPlayer) Then	;     , 
			DelEgg(e)							;   
			score=score+1						;   
		ElseIf	EntityY(e\ent)<-3 Then 			;         , 
			DelEgg(e)							;  
			broken=broken+1						;     :)
		EndIf
	Next
End Function

Function DelEgg(e.Egg)	;  
	FreeEntity e\ent	;    
	Delete e			;     
End Function

Function UpdatePlayer()	;  
	Local s#=0.1		;   
	If KeyDown(205) Then MoveEntity player, s,0,0	; 
	If KeyDown(203) Then MoveEntity player,-s,0,0	; 
End Function

Function NewTex(typ=0,width=128,height=128)		;    ( )
	Local buffer=GraphicsBuffer(),x%,y%			;  
	Local tex=CreateTexture(width,height,8)		;  
	SetBuffer TextureBuffer(tex)				;     
	Select typ						;   
		Case 1						;  
			Color 247,120,60
			Rect 0,0,width,height
			Color 0,0,0
			Line width/2,0,width/2,height/2
			Rect 0,height/2,(width-1),height/2-1,0
		Default:					;  
			For x=0 To width
				For y=0 To height
					Color Rnd(100,150),Rnd(180,250),Rnd(100,150)
					Plot x,y
				Next
			Next
	End Select
	SetBuffer buffer	;     
	Return tex			;    
End Function

Function CreateWorld()	;  
	Local plane=CreatePlane()		;   
	MoveEntity plane,0,-1,0			;    ! :)
	EntityTexture plane,NewTex()	;    
	
	Local c=CreateCube(),i%		;       
	EntityType c,TWall			;    
	ScaleEntity c,1.5,0.2,5		;   
	RotateEntity c,-10,0,0		;  ,    
	i=NewTex(1):ScaleTexture i,0.3,0.1	;   
	EntityTexture c,i					;    
	HideEntity c						;   , 
	For i=1 To 4						;    4 
		MoveEntity CopyEntity(c),(i-2.5)*(MeshWidth(c)+2.5),3,6		;       
	Next															;    
																	;  
	CreateLight		;    ....
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D